function Base64() {

	// private property
	_keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

	// public method for encoding
	this.encode = function(input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		input = _utf8_encode(input);
		while (i < input.length) {
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
			output = output + _keyStr.charAt(enc1) + _keyStr.charAt(enc2) + _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
		}
		return output;
	}
	// public method for decoding
	this.decode = function(input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
		while (i < input.length) {
			enc1 = _keyStr.indexOf(input.charAt(i++));
			enc2 = _keyStr.indexOf(input.charAt(i++));
			enc3 = _keyStr.indexOf(input.charAt(i++));
			enc4 = _keyStr.indexOf(input.charAt(i++));
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			output = output + String.fromCharCode(chr1);
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
		}
		output = _utf8_decode(output);
		return output;
	}
	// private method for UTF-8 encoding
	_utf8_encode = function(string) {
		string = string.replace(/\r\n/g, "\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if ((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}
		return utftext;
	}
	// private method for UTF-8 decoding
	_utf8_decode = function(utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
		while (i < utftext.length) {
			c = utftext.charCodeAt(i);
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			} else if ((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i + 1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			} else {
				c2 = utftext.charCodeAt(i + 1);
				c3 = utftext.charCodeAt(i + 2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		return string;
	}
}

//SHA1加密算法
function SHA1(msg) {
	function rotate_left(n, s) {
		var t4 = (n << s ) | (n >>> (32 - s));
		return t4;
	};

	function lsb_hex(val) {
		var str = "";
		var i;
		var vh;
		var vl;

		for ( i = 0; i <= 6; i += 2) {
			vh = (val >>> (i * 4 + 4)) & 0x0f;
			vl = (val >>> (i * 4)) & 0x0f;
			str += vh.toString(16) + vl.toString(16);
		}
		return str;
	};

	function cvt_hex(val) {
		var str = "";
		var i;
		var v;

		for ( i = 7; i >= 0; i--) {
			v = (val >>> (i * 4)) & 0x0f;
			str += v.toString(16);
		}
		return str;
	};

	function Utf8Encode(string) {
		string = string.replace(/\r\n/g, "\n");
		var utftext = "";

		for (var n = 0; n < string.length; n++) {

			var c = string.charCodeAt(n);

			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if ((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	};

	var blockstart;
	var i, j;
	var W = new Array(80);
	var H0 = 0x67452301;
	var H1 = 0xEFCDAB89;
	var H2 = 0x98BADCFE;
	var H3 = 0x10325476;
	var H4 = 0xC3D2E1F0;
	var A, B, C, D, E;
	var temp;

	msg = Utf8Encode(msg);

	var msg_len = msg.length;

	var word_array = new Array();
	for ( i = 0; i < msg_len - 3; i += 4) {
		j = msg.charCodeAt(i) << 24 | msg.charCodeAt(i + 1) << 16 | msg.charCodeAt(i + 2) << 8 | msg.charCodeAt(i + 3);
		word_array.push(j);
	}

	switch (msg_len % 4) {
		case 0:
			i = 0x080000000;
			break;
		case 1:
			i = msg.charCodeAt(msg_len - 1) << 24 | 0x0800000;
			break;

		case 2:
			i = msg.charCodeAt(msg_len - 2) << 24 | msg.charCodeAt(msg_len - 1) << 16 | 0x08000;
			break;

		case 3:
			i = msg.charCodeAt(msg_len - 3) << 24 | msg.charCodeAt(msg_len - 2) << 16 | msg.charCodeAt(msg_len - 1) << 8 | 0x80;
			break;
	}

	word_array.push(i);

	while ((word_array.length % 16) != 14)
	word_array.push(0);

	word_array.push(msg_len >>> 29);
	word_array.push((msg_len << 3) & 0x0ffffffff);

	for ( blockstart = 0; blockstart < word_array.length; blockstart += 16) {

		for ( i = 0; i < 16; i++)
			W[i] = word_array[blockstart + i];
		for ( i = 16; i <= 79; i++)
			W[i] = rotate_left(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);

		A = H0;
		B = H1;
		C = H2;
		D = H3;
		E = H4;

		for ( i = 0; i <= 19; i++) {
			temp = (rotate_left(A, 5) + ((B & C) | (~B & D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B, 30);
			B = A;
			A = temp;
		}

		for ( i = 20; i <= 39; i++) {
			temp = (rotate_left(A, 5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B, 30);
			B = A;
			A = temp;
		}

		for ( i = 40; i <= 59; i++) {
			temp = (rotate_left(A, 5) + ((B & C) | (B & D) | (C & D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B, 30);
			B = A;
			A = temp;
		}

		for ( i = 60; i <= 79; i++) {
			temp = (rotate_left(A, 5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B, 30);
			B = A;
			A = temp;
		}

		H0 = (H0 + A) & 0x0ffffffff;
		H1 = (H1 + B) & 0x0ffffffff;
		H2 = (H2 + C) & 0x0ffffffff;
		H3 = (H3 + D) & 0x0ffffffff;
		H4 = (H4 + E) & 0x0ffffffff;

	}

	var temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);

	return temp.toLowerCase();
}

//常量配置
//var common_url = 'http://app151.vliang.com';    //vming请求专用地址

//vming请求专用地址
function getstor(key) {
	var val = get_loc_val('mine', key);
	if (val) {
		return val;
	} else {
		return false;
	}
}

//SESSION控制
//获取session ID 每次请求 传回
function getsid() {
	return true;
	//	$api.clearStorage ()
	var sid = $api.getStorage('sid');
	if (sid == null || sid == 'undefined' || sid == undefined) {
		var appId = 'VMING';
		var key = 'HAOHAOXUEXI1510';
		var now = Date.now();
		var appKey = SHA1(appId + "VMING" + key + "VMING" + now) + "." + now;
		var headers = {
			'X-Requested-With' : 'XMLHttpRequest',
			'X-Token-With' : appKey,
			'Content-Type' : 'application/x-www-form-urlencoded; charset=UTF-8'
		};
		api.ajax({
			url : common_url + '/api/getsid',
			method : 'post',
			cache : false,
			headers : headers
		}, function(ret, err) {
			$api.setStorage('sid', ret.info.sid);
			sid = ret.info.sid;
		});
	}
	return sid;
}

var common_url = 'https://www.bigga.cn/app/28aeb56bf14c9a5f826f8ad65bc6d7f1.php';
//var common_url = 'http://192.168.1.106/batuo_new/app/28aeb56bf14c9a5f826f8ad65bc6d7f1.php';

//ajax重写
function ajaxRequest(url, method, bodyParam, callBack) 
{
	var token = $api.getStorage('token');
	
	var appId   = 'BatuoSports';
	var key     = '#adsl92xd19753mbv!';
	var now     = Date.now();
	var appKey  = SHA1(appId + "Good" + key + "Boy" + now) + "." + now;
	var headers = 
	{
		'X-Requested-With' : 'XMLHttpRequest',
		'X-Token-Para' : now,
		'X-Token-With' : appKey,
		'Content-Type' : 'application/x-www-form-urlencoded; charset=UTF-8'
	};		
	
	var deviceId       = api.deviceId;
	bodyParam.deviceId = deviceId;
	
	bodyParam.token    = token;
	
	//alert('token='+token+',deviceId='+deviceId);
	console.log('ajaxRequest =='+url+'====='+JSON.stringify(bodyParam));
	
	api.ajax({
		url : common_url + '?method=' + url,
		method : method,
		cache : false,
		timeout: 120,
		headers : headers,
		data : {
			values : bodyParam
		}
	}, 
	function(ret, err) 
	{
		api.hideProgress();
		callBack(ret, err);
	});
}

function upload_img(url, img, bodyParam, callBack) 
{
	if (!getsid()) 
	{
		getsid();
	}
	
	var appId  = 'BatuoSports';
	var key    = '#adsl92xd19753mbv!';
	var now    = Date.now();
	var appKey = SHA1(appId + "Good" + key + "Boy" + now) + "." + now;
	var headers = 
	{
		'X-Requested-With' : 'XMLHttpRequest',
		'X-Token-Para' : now,
		'X-Token-With' : appKey		
	};		
	
	var token = $api.getStorage('token');
	
	var deviceId       = api.deviceId;
	bodyParam.deviceId = deviceId;
	
	bodyParam.token    = token;
	
	//alert('token='+token+',deviceId='+deviceId);
	console.log('ajaxRequest =='+url+'====='+JSON.stringify(bodyParam));
	
	api.ajax({
		url : common_url + '?method=' + url,
		method : 'post',
		headers : headers,
		data : {
			values : bodyParam,
			files : img
		}
	}, 
	function(ret, err) 
	{
		api.hideProgress();
		
		//alert('ret.dsc='+ret.error_desc);
		
		if (err) {
			api.toast({
				msg : err.msg
			});
			return false;
		}
		callBack(ret, err);
	});
}


//时间戳转成对应日期时间，格式为：2009-03-23
function timetoDate(tm) {
	var date = new Date(parseInt(tm) * 1000);
	var month = date.getMonth() + 1;
	var day = date.getDate();
	if (month < 10)
		month = "0" + month;
	if (day < 10)
		day = "0" + day;

	return date.getFullYear() + "-" + month + "-" + day;
}

//时间戳转日期
function formatDate(now) {
	var date = new Date(now);
	Y = date.getFullYear();
	M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1);
	D = date.getDate();
	h = date.getHours();
	m = date.getMinutes();
	s = date.getSeconds();
	return Y + M + D;
}

//对应图片缓存
function imgStor(url) {
	var url = url;
	api.imageCache({
		url : url
	}, function(ret, err) {
		//			alert("AA");
		if (ret) {
			var path = ret.url;
			$api.setStorage("img", {
				"url" : url,
				"thumb" : path
			});
		}
	});
}			       
//判断是否为空
function isEmpty(data) {
	if (isEmpty1(data) || isEmpty2(data)) {
		return true;
	}
	return false;
}

function isEmpty1(data) {
	if (data == undefined || data == null || data == "" || data=='NULL' || data==false || data=='false') {
		return true;
	}
	return false;
}

function isEmpty2(v) {
	switch (typeof v) {
		case 'undefined' :
			return true;
		case 'string' :
			if ($api.trim(v).length == 0)
				return true;
			break;
		case 'boolean' :
			if (!v)
				return true;
			break;
		case 'number' :
			if (0 === v)
				return true;
			break;
		case 'object' :
			if (null === v)
				return true;
			if (undefined !== v.length && v.length == 0)
				return true;
			for (var k in v) {
				return false;
			}
			return true;
			break;
	}
	return false;
}

//open tab
//跳转到登录页面
function to_login1() {
	
	$api.rmStorage('mine');
	$api.rmStorage('sina');
	$api.rmStorage('wx');
	$api.rmStorage('addr');
	$api.rmStorage('c_c');
	$api.setStorage("yxoutlogin", 2);
//	从
	
	api.openWin({
		name : 'login_head_w',
		url : 'login_head_w.html',
		opaque : true,
		reload : true,
		vScrollBarEnabled : false
	});
	
}

function get_loc_val(key, index) {
	var val = $api.getStorage(key);
	if (isEmpty(val)) {
		return false;
	}
	if (isEmpty(val[index])) {
		return false;
	}
	return val[index];
}

function open_alert(title, content, m,src) {
	var width = api.winWidth;
	var height = api.winHeight;
	api.openFrame({
		name : 'mask_f',
		url : 'mask_f.html',
		bounces : false,
		opaque : true,
		reload : true,
		vScrollBarEnabled : false,
		pageParam : {
			headerHeight : 0,
			title : title,
			content : content,
			m : m,
			src:src,
		},
		rect : {
			x : 0,
			y : 0,
			w : width,
			h : height
		}
	});
}
function app_installed(appBundle,callback)
{
	api.appInstalled({
		    appBundle: appBundle
		},function(ret,err){
		    if (ret.installed) {
				callback(true);	
		    } else {
				callback(false);
		    }
		});	
}









/**
 * 判断是否是空
 * @param value
 */
function isDefine(value){
	if (value == null || value == "" || value == "undefined" || value == undefined || value == "null" || value == "(null)" || value == 'NULL' || typeof (value) == 'undefined'){
		return false;
	}else{
		value = value + "";
		value = value.replace(/\s/g, "");
		if (value == ""){
			return false;
		}
		return true;
	}
}


//判断是否登录
function isLogin()
{
	var token  = $api.getStorage('token');
	var mobile = getstor('mobile');
	
	if(!isDefine(token) || !isDefine(mobile))
	{
		return false;
	}
	
	return true;
}


function to_login(from, page, index) 
{	
	console.log('to_login =page===='+page+',from='+from);
	
	//alert('to_login');
	if(from == undefined || from == '')
	{
		return;
	}
	
	if(page == undefined || page == '')
	{
		return;
	}
	
	var prefix = '';
	if(from == 'index')
	{
		//url = 'html/register_head.html';
		prefix = 'html/';
	}
	else
	{
		//url = './register_head.html';
		prefix = './';
	}
		
	$api.rmStorage('mine');
	$api.rmStorage('token');
	
	console.log('to_login =111====');
	
	api.openWin({
		name : 'login2',
		url : prefix+'login2.html',
		opaque : true,
		pageParam : 
		{
			page: page,
			index: index
		},
		reload : true,
		vScrollBarEnabled : false
	});
	
	console.log('to_login =222====');
	
}




function push_to_login(data,page)
{	
	console.log('push_to_login =page===='+page);
	
	//alert('to_login');
	if(data == undefined || data == '')
	{
		return;
	}
	
	if(page == undefined || page == '')
	{
		return;
	}	
		
	$api.rmStorage('mine');
	$api.rmStorage('token');
	
	console.log('push_to_login =111====');
	
	/*
	api.openWin({
		name : 'login2',
		url : 'html/login2.html',
		opaque : true,
		pageParam : 
		{
			page: page,
			data: data
		},
		reload : true,
		vScrollBarEnabled : false
	});
	*/
	
	
	var width  = api.winWidth;
	var height = api.winHeight;
	api.openFrame({
		name : 'login2',
		//url : 'html/' + page + '.html',
		url : 'html/login2.html',
		bounces : false,
		opaque : false,
		vScrollBarEnabled : false,
		pageParam : {
			page: page,
			data: data
		},
		rect : {
			x : 0,
			y : 0,
			w : width,
			h : height
		}
	});
	
	
	/*
	if(page == 'qhongbao')
    {
    	var width  = api.winWidth;
		var height = api.winHeight;
		api.openFrame({
			name : 'login2',
			url : 'html/login2.html',
			bounces : false,
			opaque : false,
			vScrollBarEnabled : false,
			pageParam : {
				page: page,
				data: data
			},
			rect : {
				x : 0,
				y : 0,
				w : width,
				h : height
			}
		});
    }
	else if(page == 'message')
    {
    	api.openWin({
			name : 'login2',
			url : 'html/login2.html',
			opaque : true,
			pageParam : 
			{
				page: page,
				data: data
			},
			reload : true,
			vScrollBarEnabled : false
		});
    }
    */
	
	console.log('push_to_login =222====');
	
}




function logout() 
{
	$api.rmStorage('mine');
	$api.rmStorage('token');	
	
	/*
	api.closeWin({
	    name: 'mine'
	});		
	
	api.openWin({
	    name: 'root',
	    url: '../index.html',
	    pageParam: {
	        reload: true
	    }
	});
	*/
	
	api.execScript({
		name : 'root',
		script : "openTab('bill_f');"
	});
	
	//清空首页运动数据
	api.execScript({
		name : 'root',
		frameName : "bill_f",
		script : 'loadRefresh()'
	});
}

function _loadingShow(title)
{
	api.showProgress({
		style: 'default',
		animationType: 'fade',
		title: title||'数据加载中',
		text: '请稍候',
		modal: true
	});
}

function _loadingHide()
{
	api.hideProgress();
}


//点击用户协议跳转的页面
function openNext(xyc, id) 
{
	api.openWin({
		name : xyc,
		url : xyc + '.html',
		opaque : true,
		bounces :false,			
		vScrollBarEnabled : false,
		pageParam : {
			count : id
		}
	});
}

function openNextDuo(xyc, id, type) 
{
	api.openWin({
		name : xyc,
		url : xyc + '.html',
		opaque : true,
		bounces :false,			
		vScrollBarEnabled : false,
		pageParam : {
			count : id,
			type : type
		}
	});
}

function go_there(page, from) 
{	
	console.log('go_there =page===='+page+',from='+from);
	
			
	if(page == '')
	{
		return;
	}		
	else if(page == 'mine')
	{		
		if(from == 'register')
		{
			
			console.log('go_there =register1====');
			/*
			api.closeWin({
			    name: 'select_sex'
			});
			
			api.closeWin({
			    name: 'register2'
			});	
			
			api.closeWin({
			    name: 'login2'
			});	
			*/
			
			api.closeToWin({
			    name: 'root'
			});	
			
			console.log('go_there =register2====');		
		}
		else if(from == 'login')
		{
			/*
			api.closeWin({
			    name: 'login2'
			});
			*/
			
			api.closeToWin({
			    name: 'root'
			});	
		}	
		
		api.execScript({
			name : 'root',
            frameName : "mi_f",			
			script : 'update_device()'
		});	
		
		api.execScript({
			name : 'root',
			frameName : "bill_f",
			script : 'loadRefresh()'
		});
		
	}
	else if(page == 'saoma')
	{	
		if(from == 'login')
		{
			api.closeWin({
			    name: 'login2'
			});	
		}
				
		api.execScript({
			name : 'root',
            frameName : "ball",
			script : 'openSaoma()'
		});	
	}
	else if(page == 'kaluli')
	{			
		if(from == 'login')
		{
			api.closeWin({
			    name: 'login2'
			});	
		}	
		
		api.execScript({
			name : 'root',
            frameName : "xinshui_f",			
			script : 'get_data()'
		});	
	}
	else if(page == 'message')
	{			
		if(from == 'login')
		{
			api.closeWin({
			    name: 'login2'
			});	
		}	
		
		api.execScript({
			name : 'root',
            frameName : "message",			
			script : 'get_data()'
		});	
	}
	else
	{
		api.closeToWin({
		    name: 'root'
		});	
	}
	/*
	api.closeWin({
	    name: 'select_sex'
	});
	*/
}

function AntiSqlValid(oField )
{
	//alert('11');
	re = /select|update|delete|exec|count|'|"|=|;|>|<|%/i;
	if ( re.test(oField) )
	{
		//alert('22');
		//alert("请您不要在参数中输入特殊字符和SQL关键字！"); //注意中文乱码		
		return false;
	}
	
	return true;
}

//下拉刷新完成
function pullRefreshDone (callback)
{
	api.refreshHeaderLoadDone();
	if(isDefine(callback)){
		callback();
	}
}

//下拉刷新
function pullRefresh(callback)
{
	api.setRefreshHeaderInfo({
		visible: true,
		loadingImg: 'widget://image/refresh.png',
		bgColor: '#eee',
		textColor: '#aaa',
		textDown: '下拉刷新',
		textUp: '松开刷新',
		showTime: true
	}, function(ret, err)
	{
		if(ret)
		{
			if(isDefine(callback))
			{
				callback();
			}
		}
	});
}


//判断url中的参数是否包含needLogin=true
function isNeedLoginUrl(url)
{
	var isNeddLogin = getUrlParam(url,'needLogin');
	return isTrue(isNeddLogin);
}


//获取url中的指定name的参数
function getUrlParam(url,name) 
{
	if(!isDefine(url) || url.indexOf('?') == -1){
		return '';
	}
	url = url.substr(url.indexOf('?'));
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)","i");
	var r = url.substr(1).match(reg);
	if (r!=null){
		return (r[2].split('#')[0]);
	}else{
		return null;
	}
}

function isTrue(value)
{
	if(value == 'NO' || value == 'false' || value == false){
		return false;
	}else if(value == 'YES' || value == 'true' || value == true){
		return true;
	}else{
		return false;
	}
}


function openDialogAlert(data,callback)
{
	var dialogBox = api.require('dialogBox');
	dialogBox.alert(data, function(ret) {
		if(typeof callback == 'function'){
			callback(ret);
		}
		dialogBox.close({
			dialogName: 'alert'
		});
	});
}


//callback 不能是function对象，只能是字符串函数名
function setNavData(icon,text,callback,extra,navClass){
	if(!isDefine(text)){
		text = '';
	}
	if(!isDefine(extra)){
		extra = '';
	}
	return {
		icon:icon,
		text:text,
		callback:callback,
		extra:extra,
		navClass:navClass
	}
}

function setNav(leftNav,border,rightNav,headerBg){
	return {
		leftNav:leftNav,
		border:border,
		rightNav:rightNav,
		headerBg:headerBg
	}
}

function setFrame(bounces,data,allowEdit,progress,scaleEnabled,vScrollBarEnabled){
	return {
		bounces:bounces,
		allowEdit:allowEdit,
		progress:progress,
		scaleEnabled:scaleEnabled,
		vScrollBarEnabled:vScrollBarEnabled,
		data:data
	}
}

//打开新窗体和内置frame
function openNewWinFrame(name,title,params,from,url,animation,page,umengPage){
	if (!isDefine(url)) {
		url = 'header_new.html';
	}
	if(api.winName == 'root' && (from.frameName == null || from.frameName == '')){
		url = './html/' + url;
	}
	if(!isDefine(animation)){
		animation = {
			type:"push",                //动画类型（详见动画类型常量）
			subType:"from_right",       //动画子类型（详见动画子类型常量）
			duration:300                //动画过渡时间，默认300毫秒
		};
	}
	page = isDefine(page) ? page : name+'.html';
	umengPage = isDefine(umengPage) ? umengPage : title;
	var winName = name+'Win';
	var frameName = name+'Frame';
	console.log(getLogStr(new Array('openNewWinFrame',winName,url,{
		page: page,
		name: frameName,
		animation: animation,
		title: title,
		from:from,
		data: params,
		umengPage:umengPage
	})));
	api.openWin({
		name: winName,
		url: url,
		animation: animation,
		softInputMode:'resize',
		slidBackType:'edge',
		delay:100,
		pageParam:{
			page: page,
			name: frameName,
			title: title,
			from:from,
			data: params,
			umengPage:umengPage
		}
	});
}

function getLogStr(array){
	//if(api && !api.debug){return '';}
	for(var i in array){
		if(typeof array[i] == 'object'){
			array[i] = JSON.stringify(array[i]);
		}
	}
	return array.toString();
}


function toastMsg(msg)
{
	if(typeof msg == 'undefined')
	{
		msg = '未知错误';
	}
	
	api.toast({
		msg: msg,
		duration:2000,
		location: 'bottom'
	});
}


function openScanner(uc_id)
{
	console.log('===openScanner==uc_id=='+uc_id);
	
	var FNScanner = api.require('FNScanner');
	
	if(!isDefine(FNScanner))
    {
    	return;
    }
    
    FNScanner.open({
           
    },
    function( ret, err )
    {        
        if( ret )
        {
            //alert( JSON.stringify( ret ) );
            if(ret.eventType=="show")
            {
                //openscanline(frameWidth/2-100,frameHeight/2-100);
            }
            if(ret.eventType=="success")
            {
                 //alert('content='+ret.content);
                 //return;
                 
                var result = ret.content;
                if(!isDefine(result))
				{
					api.toast({
						msg : '扫码失败！',
						location : 'middle'
					});
					
					//api.closeFrame();
		
					return false;
				}
				
				var mobile = getstor('mobile');
	
				if(!isDefine(mobile))
				{
					api.toast({
						msg : '扫码失败！',
						location : 'middle'
					});
					
					//api.closeFrame();
		
					return false;
				}	
                 
                var baiduLocation = api.require('baiduLocation');
				baiduLocation.getLocation(
			    function(ret, err)
			    {			    	
			    	//alert(err.msg);
			    	if(err)
			    	{
						api.toast({
							msg:err.msg
						});
			            
			            //api.closeFrame();
			            
			            return false;
			    	}				        
			        
			        if(ret)
			        {	
			        	var loc = ret.longitude+','+ret.latitude;
			        	//var loc = '120.65815, 31.290026';				           
			            
			            ajaxRequest('preScanSite','post',{loc:loc, result:result, mobile:mobile, uc_id:uc_id},
						function(ret,err)
						{
							//alert('status='+ret.status);
							//alert('desc='+ret.error_desc);
							
							console.log('preScanSite =return===='+JSON.stringify(ret));	
										
							if(err)
							{
								api.toast({
				                    msg:err.msg
				                });
				                
				                //api.closeFrame();
				                
				                return false;
							}
							if(ret.status == '0')
							{	
								var site_name = ret.site_name;
								var amount    = ret.amount;		
								
								if(isDefine(uc_id))						
								{
									H.openFrame('sjqscan_confirm', 'sjqscan_confirm.html', {loc:loc, result:result, mobile:mobile, site_name:site_name, amount:amount, uc_id:uc_id}, { bounces: false });									
								}
								else
								{
									H.openFrame('scan_confirm', 'scan_confirm.html', {loc:loc, result:result, mobile:mobile, site_name:site_name, amount:amount}, { bounces: false });
								}
								
								
										
								/*						
								//更新首页运动数据
								api.execScript({
									name : 'root',
									frameName : "bill_f",
									script : 'loadRefresh()'
								});
								
								var audio = api.require('audio');
								audio.play({
								    path: 'widget://image/dindong.mp3'
								}, 
								function(ret, err) 
								{
								    if (ret) 
								    {
								        api.closeWin();
								        
								        openNextDuo('scan_sucess', site_name, amount);
								    } 
								    else 
								    {
								        api.closeWin();
								    }
								});
								*/
								
							}
							else
							{
								if(ret.error_desc == '验证登录会话失败')
								{
									to_login('other','saoma');
									
									//api.closeFrame();
								}
								else
								{
									//api.closeFrame();
									
									api.alert({
									    title: '扫码失败',
									    msg: ret.error_desc
									});
									
									
								}								
							}				
						});	        
			    		        
			        }
			        else
			        {
			        	api.toast({
							msg:err.msg
						});
			            
			            return false;
			        }
			    });
            }
        }
        else
        {
            alert( JSON.stringify( err ) );
        }
    });
}
